VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} FormModelProperties 
   Caption         =   "ModelProperties"
   ClientHeight    =   5400
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   2745
   OleObjectBlob   =   "FormModelProperties.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "FormModelProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' --------------------------------------------------------------------03/09/2007
' ModelProperties.swp               Written by Leonard Kikstra,
'                                   Copyright 2004-2007, Leonard Kikstra
'                                   Downloaded from Lenny's SolidWorks Resources
'                                        at http://www.lennyworks.com/solidworks
' ------------------------------------------------------------------------------
' Based on ModelColor.swp V2.5
'------------------------------------------------------------------------------
' Notes: Source file must be in same directory as macro file.
'        Source file must have same name as macro file with '.ini' extension.
'------------------------------------------------------------------------------
' Revision History
'        1.00   09/13/2004  - Initial creation with embedded model colors
'        1.10   05/25/2005  - Revised for SolidWorks 2004 & 2005
'                           - Added option hidden edges in wireframe display
'        1.20   03/09/2007  - Added new look to macro
'------------------------------------------------------------------------------
Dim Source      As String
Dim swxVersion  As String

Private Sub CommandAbout_Click()
  FormAbout.Show
End Sub

Private Sub CommandClose_Click()
  End
End Sub

Private Sub CommandButton01_Click()
  SetColorForAll 1
End Sub
Private Sub CommandButton02_Click()
  SetColorForAll 2
End Sub
Private Sub CommandButton03_Click()
  SetColorForAll 3
End Sub
Private Sub CommandButton04_Click()
  SetColorForAll 4
End Sub
Private Sub CommandButton05_Click()
  SetColorForAll 5
End Sub
Private Sub CommandButton06_Click()
  SetColorForAll 6
End Sub
Private Sub CommandButton07_Click()
  SetColorForAll 7
End Sub
Private Sub CommandButton08_Click()
  SetColorForAll 8
End Sub
Private Sub CommandButton09_Click()
  SetColorForAll 9
End Sub
Private Sub CommandButton10_Click()
  SetColorForAll 10
End Sub
Private Sub CommandButton11_Click()
  SetColorForAll 11
End Sub
Private Sub CommandButton12_Click()
  SetColorForAll 12
End Sub
Private Sub CommandButton13_Click()
  SetColorForAll 13
End Sub
Private Sub CommandButton14_Click()
  SetColorForAll 14
End Sub
Private Sub CommandButton15_Click()
  SetColorForAll 15
End Sub
Private Sub CommandButton16_Click()
  SetColorForAll 16
End Sub
Private Sub CommandButton17_Click()
  SetColorForAll 17
End Sub
Private Sub CommandButton18_Click()
  SetColorForAll 18
End Sub
Private Sub CommandButton19_Click()
  SetColorForAll 19
End Sub
Private Sub CommandButton20_Click()
  SetColorForAll 20
End Sub
Private Sub CommandButton21_Click()
  SetColorForAll 21
End Sub
Private Sub CommandButton22_Click()
  SetColorForAll 22
End Sub
Private Sub CommandButton23_Click()
  SetColorForAll 23
End Sub
Private Sub CommandButton24_Click()
  SetColorForAll 24
End Sub

Private Sub ComboBoxApply_Change()
  CheckBoxEdgesShadedModeDisplay.Enabled = True                     ' v1.10
  CheckBoxDisplayShadowsInShadedMode.Enabled = True                 ' v1.10
  CheckBoxShowHiddenInWireFrame.Enabled = False                     ' v1.10
  Select Case ComboBoxApply.ListIndex
         Case 0     ' Shaded only
                CheckBoxEdgesShadedModeDisplay_Click                ' v1.10
         Case 1     ' Wireframe only
                CheckBoxShowHiddenInWireFrame_Click                 ' v1.10
                CheckBoxShowHiddenInWireFrame.Enabled = True        ' v1.10
                CheckBoxEdgesShadedModeDisplay.Enabled = False      ' v1.10
                CheckBoxDisplayShadowsInShadedMode.Enabled = False  ' v1.10
         Case 2     ' Shaded & Wireframe
                CheckBoxEdgesShadedModeDisplay_Click                ' v1.10
         Case Else
  End Select
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub ComboBoxColorSet_Change()
  If ComboBoxColorSet.ListIndex < 1 Then
    BasicColors
  Else
    OptionColors
  End If
End Sub

Private Sub UpdateSelected(Model)
  Select Case FormModelProperties.ComboBoxApply.ListIndex
         Case 0     ' Shaded only
                AssemblyTraverse.CompShadedColor Model
         Case 1     ' Wireframe only
                AssemblyTraverse.CompWireframeColor Model
         Case 2     ' Shaded & Wireframe
                AssemblyTraverse.CompShadedColor Model
                AssemblyTraverse.CompWireframeColor Model
         Case Else
  End Select
  ModelDoc2.ForceRebuild3 True
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub SetColorForAll(Number As Integer)
  SelectedColor = ButtonObj(Number).BackColor
  If ActiveModelType = swDocAssembly Then
    If Selection = False Then
      Set configuration = ModelDoc2.GetActiveConfiguration
      Set RootComponent = configuration.GetRootComponent()
      AssemblyTraverse.TraverseComponent RootComponent, 0
    Else              ' Selection = True
      For x = 1 To SelectCount
        Set SelObjDoc = SelectedObjects(x).GetModelDoc
        FileTyp = SelObjDoc.GetType
        If FileTyp = swDocAssembly Then
          Set configuration = SelObjDoc.GetActiveConfiguration
          Set RootComponent = configuration.GetRootComponent()
          AssemblyTraverse.TraverseComponent RootComponent, 0
        Else          ' Doc <> assembly
          UpdateSelected SelObjDoc
        End If        ' Doc type
      Next x
    End If            ' Selection
  Else
  Select Case ComboBoxApply.ListIndex                   ' v2.5 Select Added
         Case 0
                SetShadedColor SelectedColor
         Case 1
                SetWireframeColor SelectedColor
         Case 2
                SetShadedColor SelectedColor
                SetWireframeColor SelectedColor
         Case Else
  End Select
  End If
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub SetShadedColor(Color As Long)               ' v2.5 Subroutine Added
  MyColor = Right$("000000" + Hex(Color), 6)
  RetVar = ModelDoc2.MaterialPropertyValues             ' Read props from model
    RetVar(0) = Val("&H" + Mid(MyColor, 5, 2)) / 255    ' Red Value
    RetVar(1) = Val("&H" + Mid(MyColor, 3, 2)) / 255    ' Green Value
    RetVar(2) = Val("&H" + Mid(MyColor, 1, 2)) / 255    ' Blue Value
  ' RetVar(3)                                           ' Ambient
  ' RetVar(4)                                           ' Diffuse
  ' RetVar(5)                                           ' Specularity
  ' RetVar(6)                                           ' Shininess
  ' RetVar(7)                                           ' Transparency
  ' RetVar(8)                                           ' Emission
  ModelDoc2.MaterialPropertyValues = RetVar             ' Write props to model
End Sub

Private Sub SetWireframeColor(Color As Long)            ' v2.5 Subroutine Added
    ModelDoc2.SetUserPreferenceIntegerValue _
        swDocumentColorWireFrame, Color
    ModelDoc2.SetUserPreferenceIntegerValue _
        swDocumentColorHidden, Color
End Sub

Private Sub ReadOptions()
  ' Read macro option(s) from ini file
  ListBoxColorList.Clear
  Dim ColorVal As String
  Dim ColorNam As String
  Open Source For Input As #1                           ' Open source file.
  Do While Not EOF(1)                                   ' Loop until end file.
    Input #1, Reader                                    ' Read data line.
    If Reader = "[OPTIONS]" Then                        ' Looking for section.
      ApplyValue = 0
      Do While Not EOF(1)                               ' Loop until end of file.
        Input #1, ProgOption                            ' Read data line.
        If UCase(Left$(ProgOption, 13)) = UCase("ApplyToShaded") Then
          If UCase(Mid$(ProgOption, 15)) = UCase("True") Then _
            ApplyValue = ApplyValue + 1
        ElseIf UCase(Left$(ProgOption, 16)) = UCase("ApplyToWireframe") Then
          If UCase(Mid$(ProgOption, 18)) = UCase("True") Then _
            ApplyValue = ApplyValue + 2
        ElseIf UCase(Left$(ProgOption, 17)) = UCase("ControlResolution") Then
            Resolution = Int(Mid$(ProgOption, 19))
        Else
          GoTo EndOptionRead
        End If
      Loop
EndOptionRead:
' ComboBoxApply.ListIndex = ApplyValue - 1
    ElseIf (Left$(Reader, 1) = "[") And (Right$(Reader, 1) = "]") Then
      ComboBoxColorSet.AddItem Mid$(Reader, 2, Len(Reader) - 2)
    End If
  Loop
  Close #1    ' Close file.
End Sub

Private Sub AddColor(ColorValue As String, ColorName As String)
  If UCase(Left(ColorValue, 2)) = "&H" Then
    Col_Red = Val("&H" + Mid(ColorValue, 7, 2))         ' Red Value
    Col_Grn = Val("&H" + Mid(ColorValue, 5, 2))         ' Green Value
    Col_Blu = Val("&H" + Mid(ColorValue, 3, 2))         ' Blue Value
    ListBoxColorList.AddItem RGB(Col_Red, Col_Grn, Col_Blu)
  Else
    ListBoxColorList.AddItem TopColor
  End If
  ListBoxColorList.List(ListBoxColorList.ListCount - 1, 1) = ColorName
End Sub

Private Sub ShowColors(Offset As Integer)
  SpinButtonColorGrid.Max = Int(((ListBoxColorList.ListCount - 25) / 24) + 1) * 24
  If ListBoxColorList.ListCount > 24 Then
    SpinButtonColorGrid.Enabled = True
  Else
    SpinButtonColorGrid.Enabled = False
  End If
  For x = 1 To 24
    If x + Offset < ListBoxColorList.ListCount + 1 Then
      ButtonObj(x).BackColor = ListBoxColorList.List(x + Offset - 1, 0)
      ButtonObj(x).ControlTipText = ListBoxColorList.List(x + Offset - 1, 1)
      ButtonObj(x).Enabled = True
    Else
      ButtonObj(x).Enabled = False
      ButtonObj(x).BackColor = vbButtonFace
    End If
  Next x
End Sub

Private Sub ShowColorPallet(Button As Object, ColorVal As String, ColorName As String)
End Sub

Private Sub OptionColors()
  ListBoxColorList.Clear
  SpinButtonColorGrid.Value = 0
  ' Read color list from ini file
  ListBoxColorList.Clear
  Dim ColorVal As String
  Dim ColorNam As String
  Open Source For Input As #1                           ' Open source file.
  Do While Not EOF(1)                                   ' Loop until end file.
    Input #1, Reader                                    ' Read data line.
    If Reader = "[" & ComboBoxColorSet.Value & "]" Then ' Looking for section.
      Do While Not EOF(1)                               ' Loop until end of file.
        Input #1, ColorVal                              ' Read data line.
        If ColorVal <> "" Then
          Input #1, ColorNam                            ' Is name valid?
          AddColor ColorVal, ColorNam
        Else
          GoTo EndColorRead
        End If
      Loop
    End If
  Loop
EndColorRead:
  Close #1    ' Close file.
  ShowColors 0
End Sub

Private Sub BasicColors()
  ListBoxColorList.Clear
  SpinButtonColorGrid.Value = 0
  ' Predefined color list
  AddColor "&H000080", "Navy Blue"
  AddColor "&H008080", "Teal"
  AddColor "&H008000", "Dark Green"
  AddColor "&H808000", "Olive"
  AddColor "&H800000", "Maroon Red"
  AddColor "&H800080", "Dark Purple"
  AddColor "&H0000C0", "Blue"
  AddColor "&H00C0C0", "Light Teal"
  AddColor "&H00C000", "Green"
  AddColor "&HC0C000", "Dark Yellow"
  AddColor "&HC00000", "Dark Red"
  AddColor "&HC000C0", "Light Purple"
  AddColor "&H8080FF", "Light Blue"
  AddColor "&H00FFFF", "Aqua(Cyan)"
  AddColor "&H00FF00", "Lime"
  AddColor "&HFFFF00", "Yellow"
  AddColor "&HFF0000", "Red"
  AddColor "&HFF00FF", "Fuchsia"
  AddColor "&HC0C0FF", "Pale Blue"
  AddColor "&HC0FFFF", "Pale Aqua"
  AddColor "&HC0FFC0", "Pale Lime"
  AddColor "&HFFFFC0", "Pale Yellow"
  AddColor "&H000000", "Black"
  AddColor "&HFFFFFF", "White"
  ShowColors 0
End Sub

Private Sub CommandRemoveFeatureColors_Click()
  If ActiveModelType = swDocAssembly Then
    If Selection = False Then
      Set configuration = ModelDoc2.GetActiveConfiguration
      Set RootComponent = configuration.GetRootComponent()
      ' Recursively traverse the component and change model properties
      AssemblyTraverse.TraverseComponent RootComponent, 2
    Else              ' Selection = True
      For x = 1 To SelectCount
        Set SelObject = SelectedObjects(x)
        Set SelObjDoc = SelObject.GetModelDoc
        Set SelObjConfig = SelObjDoc.GetActiveConfiguration
        If SelObject.ReferencedConfiguration <> SelObjConfig.Name Then
          SelObjDoc.ShowConfiguration2 ConfigName   ' Show ref'd config
        End If                                      ' only if not active
        FileTyp = SelObjDoc.GetType
        If FileTyp = swDocAssembly Then
          Set configuration = SelObjDoc.GetActiveConfiguration
          Set RootComponent = configuration.GetRootComponent()
          AssemblyTraverse.TraverseComponent RootComponent, 2
        Else          ' Doc <> Assembly
          SelObject.RemoveMaterialProperty
          AssemblyTraverse.RemoveFaceColors SelObject
        End If        ' Doc
      Next x
    End If            ' Selection
  Else
    Set swBody = ModelDoc2.Body
    Set swFace = swBody.GetFirstFace
    While Not swFace Is Nothing
      swFace.RemoveMaterialProperty                 ' Remove face properties
      Set swFeat = swFace.GetFeature                ' Traverse faces & features
      While Not swFeat Is Nothing
        AssemblyTraverse.TraverseFeatures swFeat
        Set swFeat = swFeat.GetNextFeature
      Wend
      Set swFace = swFace.GetNextFace
    Wend
  End If
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub SpinButtonColorGrid_Change()
  ShowColors SpinButtonColorGrid.Value
End Sub

'------------------------------------------------------------------------------
' Spin box used.  Dynamically set values and apply changes to model
'------------------------------------------------------------------------------
Sub SpinSpec_Change()
  Dynamic = True
  If ActiveModelType = swDocAssembly Then
    DynAssyProp
  Else
    DynCompProp
  End If
  Dynamic = False
End Sub

Sub SpinTrans_Change()
  Dynamic = True
  If ActiveModelType = swDocAssembly Then
    DynAssyProp
  Else
    DynCompProp
  End If
  Dynamic = False
End Sub

Sub DynAssyProp()
  LabelBoxSpec.Caption = "  " + CStr(SpinSpec.Value)
  LabelBoxTrans.Caption = "  " + CStr(SpinTrans.Value)
  If Selection = False Then
    Set configuration = ModelDoc2.GetActiveConfiguration
    Set RootComponent = configuration.GetRootComponent()
    AssemblyTraverse.TraverseComponent RootComponent, 1
  Else              ' Selection = True
    For x = 1 To SelectCount
      Set SelObject = SelectedObjects(x)
      Set SelObjDoc = SelObject.GetModelDoc
      Set SelObjConfig = SelObjDoc.GetActiveConfiguration
      If SelObject.ReferencedConfiguration <> SelObjConfig.Name Then
        SelObjDoc.ShowConfiguration2 ConfigName   ' Show ref'd config
      End If                                      ' only if not active
      FileTyp = SelObjDoc.GetType
      If FileTyp = swDocAssembly Then
        Set configuration = SelObjDoc.GetActiveConfiguration
        Set RootComponent = configuration.GetRootComponent()
        AssemblyTraverse.TraverseComponent RootComponent, 1
      Else          ' Doc <> Assembly
        AssemblyTraverse.DynamicProp SelObjDoc
      End If        ' Doc
    Next x
  End If            ' Selection
  ModelDoc2.GraphicsRedraw2
End Sub

Sub DynCompProp()
  LabelBoxSpec.Caption = "  " + CStr(SpinSpec.Value)
  LabelBoxTrans.Caption = "  " + CStr(SpinTrans.Value)
  ' Is color value set properly?  If yes, then apply
  ' Set material color properties and lights
  RetVar = ModelDoc2.MaterialPropertyValues             ' Read props from model
  ' RetVar(0) =                                         ' Red Value
  ' RetVar(1) =                                         ' Green Value
  ' RetVar(2) =                                         ' Blue Value
    RetVar(3) = 1#                                      ' Ambient
    RetVar(4) = 1#                                      ' Diffuse
    RetVar(5) = SpinSpec.Value / Resolution             ' Specularity
    RetVar(6) = 1#                                      ' Shininess
    RetVar(7) = SpinTrans.Value / Resolution            ' Transparency
    RetVar(8) = 0.2                                     ' Emission
  ModelDoc2.MaterialPropertyValues = RetVar             ' Write props to model
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub CheckBoxDisplayShadowsInShadedMode_Click()
  swApp.SetUserPreferenceToggle swDisplayShadowsInShadedMode, _
        CheckBoxDisplayShadowsInShadedMode
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub CheckBoxEdgesShadedModeDisplay_Click()
  If swxVersion >= "12.0.0" Then                    ' SolidWorks 2004 and later
    Set swModel = swApp.ActiveDoc                                       ' v1.10
    Set swModView = swModel.ActiveView                                  '
    If CheckBoxEdgesShadedModeDisplay.Value = True Then                 '
      swModView.DisplayMode = swViewDisplayMode_ShadedWithEdges         '
    Else                                                                '
      swModView.DisplayMode = swViewDisplayMode_Shaded                  '
    End If                                                              '
  Else                                                                  '
    ModelDoc2.ViewDisplayShaded                                         '
    If CheckBoxEdgesShadedModeDisplay.Value = True Then                 '
        swApp.SetUserPreferenceIntegerValue swEdgesShadedModeDisplay, _
                swEdgesShadedModeDisplayHLR                             '
    Else                                                                '
        swApp.SetUserPreferenceIntegerValue swEdgesShadedModeDisplay, _
                swEdgesShadedModeDisplayNone                            '
    End If                                                              '
  End If                                                                ' v1.10
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub CheckBoxShowHiddenInWireFrame_Click()
  If swxVersion >= "12.0.0" Then                    ' SolidWorks 2004 and later
    Set swModel = swApp.ActiveDoc                                       ' v1.10
    Set swModView = swModel.ActiveView                                  '
    If CheckBoxShowHiddenInWireFrame.Value = True Then                  '
      swModView.DisplayMode = swViewDisplayMode_HiddenLinesGrayed       '
    Else                                                                '
      swModView.DisplayMode = swViewDisplayMode_Wireframe               '
    End If                                                              '
  Else                                                                  '
    If CheckBoxShowHiddenInWireFrame.Value = True Then                  '
      ModelDoc2.ViewDisplayHiddengreyed                                 '
    Else                                                                '
      ModelDoc2.ViewDisplayWireframe                                    '
    End If                                                              '
  End If                                                                '
  ModelDoc2.GraphicsRedraw2
End Sub

Private Sub UserForm_Initialize()
  swxVersion = swApp.RevisionNumber()
  Active = False
  Set ButtonObj(1) = CommandButton01 ' Place buttons into
  Set ButtonObj(2) = CommandButton02 ' variant array for
  Set ButtonObj(3) = CommandButton03 ' easier access and
  Set ButtonObj(4) = CommandButton04 ' parsing.
  Set ButtonObj(5) = CommandButton05
  Set ButtonObj(6) = CommandButton06
  Set ButtonObj(7) = CommandButton07
  Set ButtonObj(8) = CommandButton08
  Set ButtonObj(9) = CommandButton09
  Set ButtonObj(10) = CommandButton10
  Set ButtonObj(11) = CommandButton11
  Set ButtonObj(12) = CommandButton12
  Set ButtonObj(13) = CommandButton13
  Set ButtonObj(14) = CommandButton14
  Set ButtonObj(15) = CommandButton15
  Set ButtonObj(16) = CommandButton16
  Set ButtonObj(17) = CommandButton17
  Set ButtonObj(18) = CommandButton18
  Set ButtonObj(19) = CommandButton19
  Set ButtonObj(20) = CommandButton20
  Set ButtonObj(21) = CommandButton21
  Set ButtonObj(22) = CommandButton22
  Set ButtonObj(23) = CommandButton23
  Set ButtonObj(24) = CommandButton24
  ComboBoxApply.Clear
  ComboBoxApply.AddItem "Shaded Only"
  ComboBoxApply.AddItem "Wireframe Only"
  ComboBoxApply.AddItem "Shaded + Wireframe"
' ComboBoxApply.ListIndex = 0
  ComboBoxColorSet.Clear
  ComboBoxColorSet.AddItem "BASIC"
  Source = swApp.GetCurrentMacroPathName                ' Get macro path+filename
  Source = Left$(Source, Len(Source) - 3) + "ini"       ' Set source filename
  Set FileSys = CreateObject("Scripting.FileSystemObject")
  ModelDoc2.GraphicsRedraw2
  If FileSys.FileExists(Source) Then                    ' Does source file exist?
    ReadOptions
  Else              ' No source file
    ComboBoxColorSet.Enabled = False
    ComboBoxColorSet.BackColor = vbButtonFace
    Resolution = 20
  End If
' ComboBoxColorSet.ListIndex = 0
  SpinSpec.Max = Resolution
  SpinTrans.Max = Resolution
  Dynamic = False
  RemoveColors = False
' CommandRemoveFeatureColors.enabled = False
  If swApp.GetUserPreferenceIntegerValue(swEdgesShadedModeDisplay) _
           = swEdgesShadedModeDisplayHLR Then
      CheckBoxEdgesShadedModeDisplay = True
  End If
  CheckBoxDisplayShadowsInShadedMode = swApp.GetUserPreferenceToggle(swDisplayShadowsInShadedMode)
  Active = True
End Sub

