Attribute VB_Name = "ModelPropertiesMain"
' --------------------------------------------------------------------03/09/2007
' ModelProperties.swp               Written by Leonard Kikstra,
'                                   Copyright 2004-2007, Leonard Kikstra
'                                   Downloaded from Lenny's SolidWorks Resources
'                                        at http://www.lennyworks.com/solidworks
' ------------------------------------------------------------------------------
' Notes: Source file must be in same directory as macro file.
'        Source file must have same name as macro file with '.ini' extension.
'------------------------------------------------------------------------------
Global swApp             As Object
Global ModelDoc2         As Object
Global ButtonObj(24)     As Object
Global Resolution        As Integer
Global SelectedColor     As Long
Global RetVar            As Variant
Global Dynamic           As Boolean
Global RemoveColors      As Boolean
Global swSelMgr          As Object
Global swSelObj          As Object
Global SelModDoc2        As Object
Global Selection         As Boolean
Global SelectCount       As Integer
Global SelectedObjects() As Object
Global ActiveModelType   As Integer
Global Const Version = "1.20"

Public Enum swUserPreferenceIntegerValue_e
        swDocumentColorWireFrame = 184
        swDocumentColorHidden = 186
        swEdgesShadedModeDisplay = 96
        swDisplayShadowsInShadedMode = 131
End Enum

Public Enum swEdgesShadedModeDisplay_e
        swEdgesShadedModeDisplayNone = 1
        swEdgesShadedModeDisplayHLR = 2
        swEdgesShadedModeDisplayWireframe = 3
End Enum

Public Enum swViewDisplayMode_e
        swViewDisplayMode_Wireframe = 1
        swViewDisplayMode_HiddenLinesRemoved = 2
        swViewDisplayMode_HiddenLinesGrayed = 3
        swViewDisplayMode_Shaded = 4
        swViewDisplayMode_ShadedWithEdges = 5   ' only valid for a part
End Enum

Public Enum swDocumentTypes_e
        swDocNONE = 0                               '  Used to be TYPE_NONE
        swDocPART = 1                               '  Used to be TYPE_PART
        swDocAssembly = 2                           '  Used to be TYPE_ASSEMBLY
        swDocDRAWING = 3                            '  Used to be TYPE_DRAWING
        swDocSDM = 4                                '  Solid data manager.
End Enum

Public Enum swOpenDocOptions_e
        swOpenDocOptions_Silent = &H1               '  Open document silently
        swOpenDocOptions_ReadOnly = &H2             '  Open document read only
        swOpenDocOptions_ViewOnly = &H4             '  Open document view only
        swOpenDocOptions_RapidDraft = &H8           '  Convert doc to RapidDraft
        swOpenDocOptions_LoadModel = &H10           '  Load detached models Auto
        swOpenDocOptions_AutoMissingConfig = &H20   '  Aut handle missing configs
End Enum

Public Enum swSelectType_e
        swSelNOTHING = 0
        swSelEDGES = 1          '  "EDGE"
        swSelFACES = 2          '  "FACE"
        swSelVERTICES = 3       '  "VERTEX"
        swSelCOMPONENTS = 20    '  "COMPONENT"
End Enum

Sub main()
  Set swApp = CreateObject("SldWorks.Application")
  Set ModelDoc2 = swApp.ActiveDoc      ' Grab currently active document
  If ModelDoc2 Is Nothing Then         ' Check to see if a document
      MsgBox "A SolidWorks part or assembly model must be active to use this macro." _
             & Chr(13) & Chr(13) _
             & "Load a part or assembly model and try again.", vbExclamation
  Else
    ActiveModelType = ModelDoc2.GetType
    If ActiveModelType = swDocAssembly Then
      Set swSelMgr = ModelDoc2.SelectionManager
      Set swSelObj = swSelMgr.GetSelectedObject4(1)           ' Get selected
      If Not swSelObj Is Nothing Then
        SelectCount = swSelMgr.GetSelectedObjectCount
        ReDim SelectedObjects(SelectCount)
        ObjCount = 0
        For x = 1 To SelectCount
          selType = swSelMgr.GetSelectedObjectType2(x)
          If selType = swSelCOMPONENTS Then
            ObjCount = ObjCount + 1
            Set SelectedObjects(ObjCount) = swSelMgr.GetSelectedObject4(x)
          ElseIf ((selType = swSelFACES) Or _
                  (selType = swSelEDGES) Or _
                  (selType = swSelVERTICES)) Then
            ObjCount = ObjCount + 1
            Set selEntity = swSelMgr.GetSelectedObject3(x)
            Set owningComponent = selEntity.GetComponent
            Set SelectedObjects(ObjCount) = owningComponent
          End If
        Next x
        If ObjCount = 0 Then
          Response = MsgBox("No valid components selected." & Chr(13) & _
                 "Continue without selections?", _
                 vbYesNo + vbExclamation + vbDefaultButton2, "Selections?")
          If Response = vbYes Then    ' User chose Yes.
            Selection = False                                 ' Manage Assy
          Else    ' User chose No.
          Exit Sub
          End If
        ElseIf ObjCount <> SelectCount Then
          MsgBox "Not all selected items will be modified.", vbExclamation
          SelectCount = ObjCount
        End If      ' ObjCount = 0
        ModelDoc2.ClearSelection2 (All)
        Selection = True                                      ' Manage Comp
      Else                                                    ' pre-selection
        Selection = False                                     ' Manage Assy
      End If        ' swSelObj Is Nothing
      FormModelProperties.Show
    ElseIf ActiveModelType = swDocPART Then
      FormModelProperties.Show
    Else
      MsgBox "Active document is not a SolidWorks part or assembly model." _
             & Chr(13) & Chr(13) _
             & "Load a part or assembly model and try again.", vbExclamation
    End If          ' document type
  End If            ' document loaded
End Sub


